<?php

namespace App\Filament\Exports;

use App\Models\GuardPatrolEntry;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class GuardPatrolEntryExporter extends Exporter
{
    protected static ?string $model = GuardPatrolEntry::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            // ExportColumn::make('id')
            //     ->label('ID'),
            ExportColumn::make('plant.name')
                ->label('PLANT'),
            ExportColumn::make('guardNames.name')
                ->label('GUARD NAME'),
            ExportColumn::make('checkPointNames.name')
                ->label('CHECK POINT NAME'),
            // ExportColumn::make('reader_code')
            //     ->label('READER CODE'),
            ExportColumn::make('patrol_time')
                ->label('PATROL TIME'),
            ExportColumn::make('created_at')
                ->enabledByDefault(false)
                ->label('CREATED AT'),
            ExportColumn::make('created_by')
                ->enabledByDefault(false)
                ->label('CREATED BY'),
            ExportColumn::make('updated_at')
                ->enabledByDefault(false)
                ->label('UPDATED AT'),
            ExportColumn::make('Updated_by')
                ->enabledByDefault(false)
                ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your guard patrol entry export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
